<?php

    $db = JFactory::getDBO ();
    $q = 'SELECT `order_data`, `status`, `track_number` FROM `#__jshopping_baikalsr_orders` WHERE `order_id` = ' . $view->order->order_id;
    $db->setQuery ($q);
    $baikalsr_order = $db->loadAssoc ();

    $deliveryData = json_decode ($baikalsr_order ['order_data'], true);
    $orderData = $this->buildOrder ($view->order);
    
?>

<tr>
    <td>
        <b>БайкалСервис</b>
    </td>
    <td>
        <div class='baikalsr-order'>
            <div class='baikalsr-order-status'>
                
                <?php if (empty ($baikalsr_order ['status'])): ?>
                    <div class='baikalsr-order-status-text'>
                        Заявка на доставку заказа еще не отсылалась
                    </div>
                    <button onclick="showBaikalsrModal (); return false;" class="btn btn-warning">
                        Создать заявку
                    </button>
                <?php else: ?>
                    Заявка отправлена
                <?php endif ?>
            </div>
        </div>
    </td>
</tr>
<?php if ($baikalsr_order ['status'] == 'order_created'): ?>
<tr>
    <td>
        <b>Статус доставки</b>
    </td>
    <td>
        <b><?=$baikalsr_order ['track_number']?></b>
        <div class="baikalsr_status_text"></div>
    </td>
</tr>
<?php endif ?>

<div class="baikalsr-modal modal-background">
    <div class="modal-window"> 
        <h3>Создание заявки</h3>  
        <hr />
        <div class="request-form jshop_edit">
            
        </div>
    </div>
</div>

<script type="text/javascript">

<?php if ($baikalsr_order ['status'] == 'order_created'): ?>

    var track_id = '<?=$track_id?>';

    loadDeliveryStatusText (track_id);

<?php endif ?>

    var showBaikalsrModal = function () {
        jQuery ('body').addClass ('modal-open');
        jQuery ('.baikalsr-modal').css ('display', 'block');
    };

    var hideBaikalsrModal = function () {
        jQuery ('body').removeClass ('modal-open');
        jQuery ('.baikalsr-modal').css ('display', 'none');
    };

    jQuery ('.baikalsr-modal').click (function () {
        hideBaikalsrModal ();
    })

    jQuery ('.modal-window').click (function (e) {
        e.stopPropagation ();
    });

</script>

<?php if ($baikalsr_order ['status'] == ''): ?>

<script type="text/javascript">

    var departureDate = "<?=date("Y-m-d", strtotime("+1 day"))."T00:00:00"?>";
    var order_id = <?=$view->order->order_id?>;

    var order_status = 'Заказ еще не был оплачен';
    
    var order_price = 1000;
    var shipping_price = 900;

    var orderData = <?=json_encode ($orderData);?>;
    var deliveryData = <?=json_encode ($deliveryData);?>;

    var token = "<?=$token?>";

    var settings = ajaxGetSettings (token);

    var tab_count = 0;

    var emptyRow = function (text, id, val) {
        return jQuery ('<tr>')
            .append ('<td>' + text + '</td>')
            .append ('<td><div class="' + id + '">' + (val || "") + '</div></td>');
    }

    var inputRow = function (text, id, val) {
        return jQuery ('<tr>')
            .append ('<td>' + text + '</td>')
            .append ('<td><input type="text" class="' + id + '" value="' + (val || "") + '" /></td>');
    }

    var createRequestForm = function () {
        jQuery ('.request-form')
            .append ('<h4>Заявка</h4>')
            .append (
                jQuery ('<table>')
                .append (`
                    <tr class="baikalsr-contragent">
                        <td style="min-width: 220px; vertical-align: top; ">Контрагент</td>
                        <td> 
                            <select class="select2 baikalsr-ajax-contragent" id="contragent" style='margin-bottom: 0; '></select> 
                        </td>
                    </tr>
                `)
                .append (`
                    <tr class="cargo_pickup_date">
                        <td style="min-width: 220px; ">Дата забора груза</td>
                        <td>
                            <input type="text" id="cargo-pickup-date"/>
                        </td>
                    </tr>
                `)
                .append (emptyRow ('Группировка товаров по местам', 'cargo-calc-type'))
            );


        jQuery ('.cargo-calc-type')
            .append (jQuery (
                '<div class="radio-1"><input type="radio" class="cargo_calc_type" name="cargo_calc_type" id="cargo_calc_1"><label for="cargo_calc_1">Каждый вид товара - отдельное грузоместо</label></div>'
            ))
            .append (jQuery (
                '<div class="radio-1"><input type="radio" class="cargo_calc_type" name="cargo_calc_type" id="cargo_calc_2"><label for="cargo_calc_2">Весь заказ - 1 грузоместо</label></div>'
            ))
        
        jQuery ('.request-form').append (`
            <div id="tabs-1">
                <ul>
                    <li class="summary-cargo-tab"><a href="#summary-cargo">Все товары в заказе</a></li>
                </ul>
                <div id="summary-cargo"></div>
            </div>
        `);

        var sumArray = Array ();

        var summary_quantity   = 0,
            summary_price      = 0,
            summary_weight     = 0,
            summary_volume     = 0;


        var place_number = 0;

        orderData.products.each (function (product) { 

            var defaultSizeInUse   = false;
            var defaultWeightInUse = false;

            var length = product.extra_fields[0].value || 0;
            var width  = product.extra_fields[1].value || 0;
            var height = product.extra_fields[2].value || 0;

            if ((parseFloat (length) <= 0) || (parseFloat (width) <= 0) || (parseFloat (height) <= 0))
            {
                length = settings.DefaultCargoLength;
                width  = settings.DefaultCargoWidth;
                height = settings.DefaultCargoHeight;

                defaultSizeInUse = true;
            }

            //console.log (length + ' ' + width + ' ' + height);

            if (parseFloat (product.weight) <= 0)
            {
                product.weight = settings.DefaultCargoWeight;
                defaultWeightInUse = true;
            }

            var volume = length * width * height;
    
            var quantity = parseInt (product.quantity);
            var qty_w, qty_s;
    
            qty_w = (defaultWeightInUse && settings.CargoDefaultSettingsType == 'unit')
                ? 1 
                : product.quantity;


            qty_s = (defaultSizeInUse && settings.CargoDefaultSettingsType == 'unit')
                ? 1 
                : product.quantity;

            place_number++;
            tab_count = place_number;
        
            for (i = 0; i < qty_s; i++) {
                sumArray.push ({ "X" : length, "Y": width, "Z": height }); 
            }

            summary_quantity += quantity;
            summary_price += product.product_data.product_item_price * product.quantity;

            summary_weight += parseFloat(product.weight) * qty_w; 
            summary_volume += parseFloat(volume);

            var sum_lwh = ajaxSumProductSizes2 (length, width, height, qty_s);
            
            //console.log (sum_lwh);

            jQuery ('#tabs-1').css ('display', 'none');
            jQuery ('#tabs-1').append ('<div class="cargo-tab" id="cargo-tab-' + place_number + '"></div>');


            var result_weight = qty_w * Math.round(product.weight * 100) / 100;

            jQuery ('#cargo-tab-' + place_number)
                .append (
                    jQuery ('<table class="baikalsr-settings-table admintable">')
                        .append (emptyRow ('Вид груза'           , 'cargo-type'))
                        .append (emptyRow ('Длина / Ширина / Высота / Вес', 'cargo-size', `
                            <input type="text" class="numeric cargo-length" placeholder="Длина"   value="` + sum_lwh ['X'] + `">
                            <input type="text" class="numeric cargo-width"  placeholder="Ширина"  value="` + sum_lwh ['Y'] + `">
                            <input type="text" class="numeric cargo-height" placeholder="Высота"  value="` + sum_lwh ['Z'] + `">
                            <input type="text" class="numeric cargo-weight" placeholder="Вес"     value="` + result_weight + `">
                        `))
                        .append (inputRow ('Одинаковые места'           , 'numeric cargo-count', 1))
                        .append (inputRow ('Оценочная стоимость (руб.)' , 'numeric cargo-price', product.product_data.product_item_price * product.quantity))
                        .append (`
                            <tr>
                                <td>
                                    Упаковка
                                </td>
                                <td>
                                    <select name="additional-services" class="additional-services" multiple="" size="5">
                                        <option value="3228">Жесткая упаковка</option>
                                        <option value="2797">Паллетный борт (индивидуальный)</option>
                                        <option value="19">Паллетирование</option>
                                        <option value="21">Пузырчатая пленка</option>
                                        <option value="22">Малый мешок (55х100см)</option>
                                        <option value="23">Средний мешок (100х150см)</option>
                                    </select>
                                </td>
                            </tr>
                            <tr class="small-bag-count" style="display: none; ">
                                <td style="min-width: 150px; ">Кол-во малых мешков</td>
                                <td>
                                    <input type="text" name="small-bag-count" class="numeric small_bag_count" value="` + parseInt (settings.SmallBagCount) + `" />
                                </td>
                            </tr>
                            <tr class="middle-bag-count" style="display: none; ">
                                <td style="min-width: 150px; ">Кол-во средних мешков</td>
                                <td>
                                    <input type="text" name="middle-bag-count" class="numeric middle_bag_count" value="` + parseInt (settings.MiddleBagCount) + `"/>
                                </td>
                            </tr>
                        `)
                );

            jQuery ('#tabs-1 ul').append (
                '<li class="cargo-list-tab"><a href="#cargo-tab-' + place_number + '">' 
                    + (product.quantity > 0 ? (product.product_name + ' x ' + parseInt (product.quantity)) : "") 
                    + '</a></li>'
            );
        })

        var sumSizeResult = ajaxSumProductSizes (sumArray);

        jQuery ('#summary-cargo')
            .append (
                jQuery ('<table class="baikalsr-settings-table admintable">')
                    .append (emptyRow ('Вид груза'           , 'cargo-type')) 
                    .append (emptyRow ('Длина / Ширина / Высота / Вес', 'cargo-size', `
                        <input type="text" class="numeric" id="summary_length" name="summary_length" placeholder="Длина"    value="` + sumSizeResult ["length"] + `">
                        <input type="text" class="numeric" id="summary_width" name="summary_width" placeholder="Ширина"     value="` + sumSizeResult ["width"] + `">
                        <input type="text" class="numeric" id="summary_height" name="summary_height" placeholder="Высота"   value="` + sumSizeResult ["height"] + `">
                        <input type="text" class="numeric" id="summary_weight" name="summary_weight" placeholder="Вес"      value="` + summary_weight + `">
                    `))
                    .append (inputRow ('Кол-во мест'    , 'summary-cargo-count', 1))
                    .append (inputRow ('Оценочная стоимость (руб.)' , 'summary-cargo-price', summary_price))
                    .append (`
                        <tr>
                            <td>
                                Упаковка
                            </td>
                            <td>
                                <select name="additional-services" class="additional-services" multiple="" size="5">
                                    <option value="3228">Жесткая упаковка</option>
                                    <option value="2797">Паллетный борт (индивидуальный)</option>
                                    <option value="19">Паллетирование</option>
                                    <option value="21">Пузырчатая пленка</option>
                                    <option value="22">Малый мешок (55х100см)</option>
                                    <option value="23">Средний мешок (100х150см)</option>
                                </select>
                            </td>
                        </tr>
                        <tr class="small-bag-count" style="display: none; ">
                            <td style="min-width: 150px; ">Кол-во малых мешков</td>
                            <td>
                                <input type="text" name="small-bag-count" class="numeric small_bag_count" value="` + parseInt (settings.SmallBagCount) + `" />
                            </td>
                        </tr>
                        <tr class="middle-bag-count" style="display: none; ">
                            <td style="min-width: 150px; ">Кол-во средних мешков</td>
                            <td>
                                <input type="text" name="middle-bag-count" class="numeric middle_bag_count" value="` + parseInt (settings.MiddleBagCount) + `"/>
                            </td>
                        </tr>
                    `)
            );            
            
        jQuery ('#tabs-1').tabs (); 

        jQuery ('.cargo-type').append ('<select class="select2 baikalsr-ajax-cargo-type"></select>');
        initCargoTypeBox(settings.DefaultCargoType);
            
        jQuery ('.request-form') 
            .append ('<h4>Автор заявки</h4>')
            .append (
                jQuery ('<table class="baikalsr-settings-table admintable">')
                    .append (inputRow ('Фамилия'      , 'author-last-name'        , settings.AuthorLastName))
                    .append (inputRow ('Имя *'        , 'author-first-name'       , settings.AuthorFirstName))
                    .append (inputRow ('Отчество'     , 'author-middle-name'      , settings.AuthorMiddleName))
                    .append (inputRow ('E-mail *'     , 'author-email'            , settings.AuthorEmail))
                    .append (inputRow ('Телефон *'    , 'author-phone'            , settings.AuthorPhone))
                    .append (inputRow ('Комментарий'  , 'author-comment'          , settings.AuthorComment))
            )
            .append ('<h4>Доставка</h4>')
            .append (emptyRow ('Доставка', 'cargo-shipping-type'))


        jQuery ('.cargo-shipping-type')
            .append (`
                <div>
                    <div class="radio-1">
                        <input type="radio" class="shipping-type" name="shipping-type" id="is_terminal" /><label for="is_terminal">До терминала</label>
                    </div>
                    <div class="radio-1">
                        <input type="radio" class="shipping-type" name="shipping-type" id="is_addr"/><label for="is_addr">До адреса</label>
                    </div>
                </div>
            `);

        jQuery ('.request-form')
            .append ('<h4>Адрес назначения</h4>')
            .append (`
                <tr>
                    <td style="min-width: 220px; ">Город</td>
                    <td>
                        <select class="select2 baikalsr-ajax-city"></select>
                    </td>
                </tr>
                <tr class="baikalsr-address">
                    <td style="min-width: 220px; ">Улица</td>
                    <td>
                        <select class="select2 baikalsr-ajax-street"></select>
                    </td>
                </tr>
                <tr class="baikalsr-address">
                    <td style="min-width: 220px; ">Дом</td>
                    <td>
                        <select class="select2 baikalsr-ajax-house"></select>
                    </td>
                </tr>
                <tr class="baikalsr-address">
                    <td style="min-width: 220px; ">Корпус / Строение</td>
                    <td>
                        <div class='baikalsr-house-data'>
                            <table>
                                <tr>
                                    <td>
                                        <input type="text" class="baikalsr-housing" placeholder="Корпус"></input>
                                    </td>
                                    <td>
                                        <input type="text" class="baikalsr-building" placeholder="Строение"></input>
                                    </td>
                                </tr>
                            </table>
                        </div>
                    </td>
                </tr>
                <tr class="baikalsr-address">
                    <td style="min-width: 220px; ">Квартира / Офис</td>
                    <td>
                        <input type="text" class="baikalsr-apt" placeholder="Квартира / Офис"></input>
                    </td>
                </tr>
                <tr class="baikalsr-terminal">
                    <td style="min-width: 220px; ">Терминал</td>
                    <td>
                        <select class="select2 baikalsr-ajax-terminal"></select>
                    </td>
                </tr>
                <tr class="baikalsr-prr">
                    <td style="min-width: 220px; ">Погрузочно-разгрузочные работы</td>
                    <td>
                        <input type="checkbox" id="baikalsr-ajax-prr"></input>
                    </td>
                </tr>
                <tr class="baikalsr-prr">
                    <td style="min-width: 220px; ">Есть лифт</td>
                    <td>
                        <input type="checkbox" id="baikalsr-ajax-elevator" disabled="disabled"></input>
                    </td>
                </tr>
                <tr class="baikalsr-prr">
                    <td style="min-width: 220px; ">Этаж</td>
                    <td>
                        <input type="text" id="baikalsr-floor" class="numeric" placeholder="Этаж" disabled="disabled"></input>
                    </td>
                </tr>
            `)

            .append ('<h4>Получатель</h4>')
            .append (
                jQuery ('<table class="baikalsr-settings-table admintable">')
        
                    .append (emptyRow ('Получатель'           , 'legalForm' , 
                    `
                        <select class='baikalsr-ajax-opf'> </select>
                    `))
                    .append (inputRow ('<div id="NameLabel">Name</div>'  , 'recepient-name' , orderData.person.first_name + ' ' + orderData.person.last_name))
                    .append (inputRow ('<div id="FirstFieldLabel">FirstField</div>'  , 'recepient-field-1' , ''))
                    .append (inputRow ('<div id="SecondFieldLabel">SecondField</div>'  , 'recepient-field-2' , ''))
                    .append (inputRow ('<div id="ContactPerson">ContactPerson</div>'  , 'recepient-contact-person' , ''))
                    .append (inputRow ('Контактный телефон *' , 'recepient-phone'  , orderData.person.phone))
                    .append (inputRow ('E-mail *'             , 'recepient-email'  , orderData.person.email))
                    .append (inputRow ('Комментарий'          , 'recepient-comment', orderData.person.comment))


            )
            
            .append ('<h4>Расчёт и оформление заявки</h4>')
            .append (`
                    <div style='padding: 10px; '>
                        <button onclick="ajaxCalculateDelivery (); return false;" class="btn btn-success">
                            Рассчитать стоимость
                        </button>
                        <button onclick="createOrder (token); return false;" class="btn btn-warning">
                            Создать заявку
                        </button>

                        &nbsp;&nbsp;

                        <span id='delivery-price'></span>

                        &nbsp;&nbsp;

                        <span id='order-status'></span>

                        <div id='delivery-price-details'></div>
                        <div id='order-errors' style='padding-top: 10px; '></div>
                    </div>
            `);

            /*
            .append ('<h4>Оплата</h4>')
            .append (
                jQuery ('<table class="baikalsr-settings-table admintable">')
                    .append (jQuery ('<tr><td colspan="2"><b>' + order_status + '</b></td></tr>'))
                    .append (jQuery ('<tr><td>К оплате за товары</td><td>' + order_price  + ' р.</td></tr>'))
                    .append (jQuery ('<tr><td>К оплате за доставку</td><td>' + shipping_price  + ' р.</td></tr>'))
            )
            */
    };
    
    var terminal_finish_only = true;

    createRequestForm();
    initAddressBoxes ();
    initContragentsBox(settings.ContragentGuid, token);
    
    initPartnerTypeBox("2_1");

    jQuery ('.baikalsr-ajax-opf').change (function () {
        var opf_arr = jQuery ('.baikalsr-ajax-opf').val ().split ('_');
        
        var legalForm = opf_arr [0];
        var type = opf_arr [1];

        if (legalForm == 2 || legalForm == 4)
        {
            jQuery ('#FirstFieldLabel').html ('Серия документа');
            jQuery ('#SecondFieldLabel').html ('Номер документа');
            jQuery ('#NameLabel').html ('ФИО *');
            jQuery ('#ContactPerson').parent ().parent ().hide ();
        }
        else
        {
            jQuery ('#FirstFieldLabel').html ('ИНН');
            jQuery ('#SecondFieldLabel').html ('КПП');
            jQuery ('#NameLabel').html ('Наименование компании *');
            jQuery ('#ContactPerson').html ('ФИО Контактного лица');
            jQuery ('#ContactPerson').parent ().parent ().show ();
        }
    }).trigger ('change');


    jQuery ('.shipping-type').change (function () {
        if (jQuery ("#is_terminal").is (":checked")) {
            jQuery ('.baikalsr-address').css ('display', 'none');
			jQuery ('.baikalsr-prr').css ('display', 'none');
            jQuery ('.baikalsr-terminal').css ('display', 'table-row');
        } else {
            jQuery ('.baikalsr-address').css ('display', 'table-row');
			jQuery ('.baikalsr-prr').css ('display', 'table-row');
            jQuery ('.baikalsr-terminal').css ('display', 'none');
        }
    })

    jQuery ('#baikalsr-ajax-prr').change (function () {
        if (jQuery ("#baikalsr-ajax-prr").is (":checked")) {
            jQuery ('.baikalsr-prr input').removeAttr ("disabled"); 
        } else {
            jQuery ('.baikalsr-prr input').attr ("disabled", "disabled"); 
        }
    });

    if (deliveryData.is_terminal) {
        loadCity (deliveryData.city);
        initTerminalBox (deliveryData.city, deliveryData.terminal);
        
        jQuery ("#is_terminal").click ();
        jQuery ('.cargo_pickup_date').show ();
    } else {
        loadAddress (
            deliveryData.city, deliveryData.street, (deliveryData.house || ""),
            deliveryData.housing, 
            deliveryData.building
        );
        jQuery ('.baikalsr-apt').val (deliveryData.apt);

        initTerminalBox (deliveryData.city, deliveryData.terminal);
        jQuery ("#is_addr").click ();
        jQuery ('.cargo_pickup_date').hide ();
    }
    
    jQuery (".additional-services").val (JSON.parse (settings.AdditionalServices)).trigger ('change');    

    jQuery (".additional-services").each (function (i, item) {
        jQuery (item).change (function () {
            var table = jQuery (this).parent ().parent ().parent ();
            
            jQuery (table).find ('.small-bag-count').css ('display', 
                (jQuery (this).val () || []).map (x => parseInt (x)).includes (22) ? 'table-row' : 'none'
            );

            jQuery (table).find ('.middle-bag-count').css ('display', 
                (jQuery (this).val () || []).map (x => parseInt (x)).includes (23) ? 'table-row' : 'none'
            );
        }).trigger ('change');
    });

    jQuery (".cargo_calc_type").change (function () {
        if (jQuery ("#cargo_calc_1").is (":checked")) {
            jQuery (".summary-cargo-tab").hide ();
            jQuery (".cargo-list-tab").show ();

            jQuery (".cargo-list-tab:first a").click ();
        } else {
            jQuery (".summary-cargo-tab").show ();
            jQuery (".cargo-list-tab").hide ();

            jQuery (".summary-cargo-tab a").click ();
        }
    })

    if (settings.CargoCalcType == "list") {
        jQuery ("#cargo_calc_1").click().trigger ('change');
    } else {
        jQuery ("#cargo_calc_2").click().trigger ('change');
    }

    jQuery ('#tabs-1').css ('display', 'block');
    
    var gatherCartData = function () {
        var cartData = { 'cargo_list': Array() };

        cartData ['cityGuid'] = jQuery ('.baikalsr-ajax-city').val ();

        if (!jQuery ("#is_terminal").is (":checked"))
        {
			cartData["House"] = jQuery ('.baikalsr-ajax-house').val ();
			if (parseInt (jQuery ("#baikalsr-ajax-prr").prop ("checked") | 0)){
				cartData ['PRR'] = 1;
				cartData ['Floor'] = jQuery ("#baikalsr-floor").val ();
				cartData ['Elevator'] = parseInt (jQuery ("#baikalsr-ajax-elevator").prop ("checked") | 0);
			}
        }

        if (!jQuery ("#cargo_calc_1").is (":checked")) {
            var length = jQuery ('#summary_length').val ();
            var width  = jQuery ('#summary_width').val ();
            var height = jQuery ('#summary_height').val ();

            var volume = length * width * height;

            var weight = jQuery ('#summary_weight').val ();
            
            var servicesobject = [];

            var additional_services = jQuery ('#summary-cargo').find ('.additional-services').val ();
        
            jQuery (additional_services).each (function (i, id) {
                var count = 1;
                
                if (parseInt (id) == 22) count = jQuery ('#summary-cargo .small_bag_count').val () || 1;
                if (parseInt (id) == 23) count = jQuery ('#summary-cargo .middle_bag_count').val () || 1;

                servicesobject.push ({ "id": id, "fields": [ { "id": id, "value": count } ] });
            });
            
            cartData ['cargo_list'].push ({
                'Length': length,
                'Width' : width,
                'Height': height,
                'Volume': volume,
                'Weight': weight,
                'Type'  : jQuery ('#summary-cargo .cargo-type select').val (),
                'Units' : jQuery ('.summary-cargo-count').val (),
                'EstimatedCost': jQuery ('.summary-cargo-price').val (),
                'servicesobject': servicesobject
                /* 'Services': jQuery ('#summary-cargo').find ('.additional-services').val () */
            });
        } else {
            jQuery ('.cargo-tab').each (function (i, v) {
                var length = jQuery (v).find ('.cargo-length').val ();
                var width  = jQuery (v).find ('.cargo-width').val ();
                var height = jQuery (v).find ('.cargo-height').val ();
                
                var volume = length * width * height;

                var weight = jQuery (v).find ('.cargo-weight').val ();

                var servicesobject = [];

                var additional_services = jQuery (v).find ('.additional-services').val ();

                //console.log (additional_services);

                jQuery (additional_services).each (function (i, id) {
                    var count = 1;
                    
                    if (parseInt (id) == 22) count = jQuery (v).find ('.small_bag_count').val () || 1;
                    if (parseInt (id) == 23) count = jQuery (v).find ('.middle_bag_count').val () || 1;

                    servicesobject.push ({ "id": id, "fields": [ { "id": id, "value": count } ] });
                });

                cartData ['cargo_list'].push ({
                    'Length': length,
                    'Width' : width,
                    'Height': height,
                    'Volume': volume,
                    'Weight': weight,
                    'Type'  : jQuery (v).find ('.cargo-type select').val (),
                    'Units' : jQuery (v).find ('.cargo-count').val (),
                    'EstimatedCost': jQuery (v).find ('.cargo-price').val (),
                    'servicesobject': servicesobject
                    /* 'Services': jQuery (v).find ('.additional-services').val () */
                });
            });
        }
        
        return cartData;
    }

    var gatherOrderParams = function () {
        var cartData = gatherCartData ();

        var departureFromTerminal = parseInt (settings.IsTerminal);
        var deliveryToTerminal    = jQuery ("#is_terminal").is (":checked");

        var sender_house_arr =  settings.SenderHouse.split ('|');

        var params = {
            "Author" : {
                "FirstName" : jQuery ('.author-first-name').val (),
                "LastName"  : jQuery ('.author-last-name').val (),
                "MiddleName": jQuery ('.author-middle-name').val (),
                "Phone"     : jQuery ('.author-phone').val (),
                "Email"     : jQuery ('.author-email').val (),
                "Comment"   : jQuery ('.author-comment').val (),
            },
            
            "Departure" : {
                "CityGuid" : settings.SenderCity
            },

            "OrdersList": [{
                "Destination": {
                    "CityGuid" : jQuery ('.baikalsr-ajax-city').val (),

                    "Consignee": {},

                    "PayerID": "Consignor",
                    "FormOfPayment": 2
                },
                "CargoList"     : [],
                "PayerID"       : "Consignor",
                "FormOfPayment" : 2
            }]
        };

        var contragentGuid = jQuery ('.baikalsr-ajax-contragent').val () || settings.ContragentGuid;

        if (contragentGuid) {
            params ["Departure"]["Consignor"] = {
                "guid"  : contragentGuid,
                "Phone" : settings.AuthorPhone,
                "Email" : settings.AuthorEmail,
                "ContactPerson":  settings.AuthorLastName + ' ' + settings.AuthorFirstName + ' ' + settings.AuthorMiddleName
            };
        } else {
            var opf_arr = settings.OPF.split ('_');

            params ["Departure"]["Consignor"] = {
                "guid"  : "",
                
                "LegalForm" : opf_arr [0],
                "Type"      : opf_arr [1],

                "Name"      : settings.CompanyName,
                "FirstField": settings.INN,
                "SecondField": settings.KPP,
                
                "Phone" : settings.Phone,
                "Email" : settings.Email,
                "ContactPerson": settings.ContactPerson
            };
        }
        
        if (departureFromTerminal) {
            params ["Departure"]["Terminal"] = settings.SenderTerminal;
        } else {
            params ["Departure"]["PickUp"] = {
                "StreetGuid" : settings.SenderStreet,
                "house"      : sender_house_arr [1],
                "housing"    : settings.SenderHousing || sender_house_arr [2],
                "building"   : settings.SenderBuilding || sender_house_arr [3],
                "apartment"  : settings.SenderApartment,
                "comment"    : settings.AddressNote,
                "Date"       : jQuery.datepicker.formatDate ('yy-mm-ddT00:00:00', jQuery ('#cargo-pickup-date').datepicker ('getDate')),
                "TimeFrom"   : "09:00",
                "TimeTo"     : "18:00",
                "PayerID"    : "Consignor",
                "FormOfPayment" : 2,
            }

            if (parseInt (settings.DefaultPRR))
            {
                params ["Departure"]["PickUp"]["Prr"] = {
                    "floor": settings.DefaultFloor,
                    "lift": settings.DefaultElevator
                };
            }
        }

        var opf_arr = jQuery ('.baikalsr-ajax-opf').val ().split ('_');
        
        var legalForm = opf_arr [0];
        var type = opf_arr [1];

        params ["OrdersList"][0]["Destination"]["Consignee"] = {
            "guid"     : "",
            "LegalForm": legalForm,
            "Type"     : type,
            "Name"     : jQuery ('.recepient-name').val (),
            "FirstField" : jQuery ('.recepient-field-1').val (),
            "SecondField": jQuery ('.recepient-field-2').val (),
            "Phone"    : jQuery ('.recepient-phone').val (),
            "Email"    : jQuery ('.recepient-email').val (),
            "ContactPerson" : jQuery ('.recepient-contact-person').val (),
        };

        if (deliveryToTerminal) {
            params ["OrdersList"][0]["Destination"]["Terminal"] = jQuery (".baikalsr-ajax-terminal").val ();
        } else {
            var street    = jQuery ('.baikalsr-ajax-street').val ();
            var house_arr = (jQuery ('.baikalsr-ajax-house').val () || "").split ('|');

            params ["OrdersList"][0]["Destination"]["Delivery"] = {
                "StreetGuid"    : street,
                "House"         : house_arr [1],
                "Housing"       : jQuery ('.baikalsr-housing').val () || house_arr [2],
                "Building"      : jQuery ('.baikalsr-building').val () || house_arr [3],
                "Apartment"     : jQuery ('.baikalsr-apt').val () || "",
                "CustomAddress" : "",
                "Comment"       : jQuery ('.recepient-comment').val (),
                "PayerID"       : "Consignor",
                "FormOfPayment" : 2
            };

            if (cartData ["PRR"])
            {
                params ["OrdersList"][0]["Destination"]["Delivery"]["Prr"] = {
                    "floor": cartData ["Floor"],
                    "lift": cartData ["Elevator"]
                };
            }
        }

        jQuery (cartData ['cargo_list']).each (function (i, product) { 
            var item = {
                "Length": product.Length,
                "Width" : product.Width,
                "Height": product.Height,
                "Volume": product.Volume,
                "Weight": product.Weight,
                "Units" : product.Units,
                "Type"  : product.Type,
                "Insurance": {
                    "EstimatedCost": product.EstimatedCost,
                    "PayerID": "Consignor",
                    "FormOfPayment": 2
                }
            };
            
            if (product.servicesobject != "")
            {
                item ["Services"] = [];
                
                jQuery (product.servicesobject).each (function (i, v) { 
                    var id    = v.fields [0].id;
                    var value = v.fields [0].value;

                    var serviceItem = {
                        "id": id,
                        "value": value,
                        "PayerID": "Consignor",
                        "FormOfPayment": 2   
                    };    

                    item ["Services"].push (serviceItem);
                });

                item ["servicesobject"] = product.servicesobject;
            }

            params ["OrdersList"][0]["CargoList"].push (item);
        });

        return params;
    }


    var validateOrderForm = function () {
        
        var deliveryToTerminal = jQuery ("#is_terminal").is (":checked");
        var summaryCargo = jQuery ("#cargo_calc_2").is (":checked"); 

        var required = [
            ".baikalsr-ajax-contragent",
            ".author-first-name",
            ".author-email",
            ".author-phone",
            ".recepient-name",
            ".recepient-phone",
            ".recepient-email",
        ];

        if (summaryCargo) {
            required.push (
                "#summary_length",
                "#summary_width",
                "#summary_height",
                "#summary_weight",
                ".summary-cargo-count",
                ".summary-cargo-price",
                "#summary-cargo .baikalsr-ajax-cargo-type"
            );
        } else {
            for (i = 1; i <= tab_count; i++) {
                required.push (
                    "#cargo-tab-" + i + " .cargo-length",
                    "#cargo-tab-" + i + " .cargo-width",
                    "#cargo-tab-" + i + " .cargo-height",
                    "#cargo-tab-" + i + " .cargo-weight",
                    "#cargo-tab-" + i + " .cargo-count", 
                    "#cargo-tab-" + i + " .cargo-price", 
                    "#cargo-tab-" + i + " .baikalsr-ajax-cargo-type"
                );
            }
        }

        if (deliveryToTerminal) {
            required.push (
                ".baikalsr-ajax-terminal"
            );
        } else {
            required.push (
                ".baikalsr-ajax-city",
                ".baikalsr-ajax-street",
                ".baikalsr-ajax-house"
            );
        };

        var hasEmptyFields = false;

        jQuery (required).each (function (i, item) {
            if ((jQuery (item).val () || "").trim () == "") {
                hasEmptyFields = true;
                jQuery (item).addClass ("form-required");
            } else {
                jQuery (item).removeClass ("form-required");
            }
        });

        if (hasEmptyFields) {
            alert ('Не заполнены необходимые поля');
            return false;
        }

        return true;
    }

    var createOrder = function () {

        if (!validateOrderForm ()) {
            return;
        }

        jQuery ('#order-errors').html ('');
        jQuery ('#order-status').html ('Отправка запроса ...');

        var order_data = gatherOrderParams ();
        
        order_data.order_id = orderData.order_id;

        result = JSON.parse (
            jQuery.ajax ({
                url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=createOrder&args=' 
                    + JSON.stringify ({ "data": order_data }) + '&token=' + token,
                async: false
            }).responseText
        );

        if (result.errors !== undefined)
        {
            jQuery (result.errors).each (function (i, error) {
                jQuery ('#order-errors').append ('<div style="color: red; ">Ошибка: ' + error.description + '</div>');
            });
        }
        else
        {
            location.reload ();
        }
        
        jQuery ('#order-status').html ('');

        //console.log (result);
    }

    var ajaxCalculateDelivery = function () {

        jQuery ('#delivery-price').html ('Отправка запроса ...');

        var cartData = gatherCartData(), 
            is_terminal = jQuery ("#is_terminal").is (":checked");

        args = JSON.stringify ({ 
            "cartData" : cartData,
            "calcType" : "list",
            "isDeliveryToTerminal" : is_terminal
        });

        console.log (args);
        
        rows = JSON.parse (
            jQuery.ajax ({
                url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=calculateOrder&args=' + args,
                async: false
            }).responseText
        );

        //console.log (rows);

        if (rows.total !== undefined) {
            jQuery ('#delivery-price').html (rows.total + ' р.');
        } else {
            jQuery ('#delivery-price').html ('<i>Рассчитывается индивидуально</i>');
        }

        if (parseInt (rows.DetailedInfo))
        {
            var summary = createShippingDetailsSummary (rows);

            jQuery ('#delivery-price-details').html (summary);

            var details = createShippingDetailsTable (rows);

            jQuery ('#delivery-price-details').append (details); 
        }
        
    };

    jQuery ('.author-phone').mask ("+9 (999) 999-9999");

    jQuery ('.recepient-phone').change (function () {
        if (jQuery (this).val () == "") {
            jQuery (this).mask ("+7 (999) 999-9999");
        }
    }).trigger ("change");
 

    jQuery (".numeric").numeric ({ 
        decimal : ".",  
        negative : false, 
        scale: 2 
    });

    jQuery.datepicker.setDefaults ({
        closeText: 'Закрыть',
        prevText: '',
        currentText: 'Сегодня',
        monthNames: ['Январь','Февраль','Март','Апрель','Май','Июнь',
            'Июль','Август','Сентябрь','Октябрь','Ноябрь','Декабрь'],
        monthNamesShort: ['Янв','Фев','Мар','Апр','Май','Июн',
            'Июл','Авг','Сен','Окт','Ноя','Дек'],
        dayNames: ['воскресенье','понедельник','вторник','среда','четверг','пятница','суббота'],
        dayNamesShort: ['вск','пнд','втр','срд','чтв','птн','сбт'],
        dayNamesMin: ['Вс','Пн','Вт','Ср','Чт','Пт','Сб'],
        weekHeader: 'Не',
        dateFormat: 'dd.mm.yy',
        firstDay: 1,
        isRTL: false,
        showMonthAfterYear: false,
        yearSuffix: ''
    });
    
    jQuery ('#cargo-pickup-date').datepicker ().mask ("99.99.9999").val (
        jQuery.datepicker.formatDate ('dd.mm.yy', new Date ())
    );

</script>

<?php endif ?>