<?php
    $shipping_data = $_SESSION ['baikalsr__shipping_data'];
	$isTerminal = $shipping_data ['is_terminal'];
?>
<script type="text/javascript">
    var rows = <?=json_encode ($rows); ?>;
    var cartData = <?=json_encode ($cartData); ?>;  
    var shippingData = <?=json_encode ($shipping_data); ?>;
</script>

<link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet" />
<link href="/plugins/jshoppingorder/baikalsr_shipping/css/common.css" rel="stylesheet" />
<script src="/plugins/jshoppingorder/baikalsr_shipping/js/select2.min.js"></script>
<script src="/plugins/jshoppingorder/baikalsr_shipping/js/common.js"></script>

<style type="text/css">
	.controls .btn-group.btn-group-yesno {
	  width: 215px;
	  max-width: 100%;
	}
	.controls .btn-group.btn-group-yesno > .btn {
	  width: 50%;
	  min-width: 40px;
	  padding: 4px 0;
	  margin-right: 0;
	}
</style>
<div id="baikalsr-calculator" class="form-horizontal">
	<div style="padding-top: 20px;">
		<div class="control-group">
			<div class="control-label name">Город</div>
			<div class="controls">
				<select class="select2 baikalsr-ajax-city"></select>
			</div>
		</div>

		<div class="control-group">
			<div class="control-label name">Доставить</div>
			<div class="controls">
				<fieldset id="jform_sendfromtype" class="btn-group btn-group-yesno radio">	
					<input type="radio" id="jform_sendfromtype1" name="baikalsr_shipping-type" onclick="sendFromType_radio(this);" onchange="sendFromType_radio(this);" value="1" <?=(!$isTerminal ? "checked" : "")?>>			
					<label for="jform_sendfromtype1" class="btn">По адресу</label>
					<input type="radio" id="jform_sendfromtype0" name="baikalsr_shipping-type" onclick="sendFromType_radio(this);" onchange="sendFromType_radio(this);" value="2" <?=($isTerminal ? "checked" : "")?>>			
					<label for="jform_sendfromtype0" class="btn">До терминала</label>
				</fieldset>
			</div>
		</div>
		<div id="baikalsr-address-group">    
			<div class="control-group">
				<div class="control-label name">Улица</div>
				<div class="controls">
					<select class="select2 baikalsr-ajax-street"></select>
				</div>
			</div>
			<div class="control-group">
				<div class="control-label name">Дом</div>
				<div class="controls">
					<select class="select2 baikalsr-ajax-house"></select>
				</div>
			</div>
			<div class="control-group">
				<div class="control-label name">Корпус</div>
				<div class="controls">
					<input type="text" class="baikalsr-housing" placeholder="Корпус"></input>
				</div>
			</div>
			<div class="control-group">
				<div class="control-label name">Строение</div>
				<div class="controls">
					<input type="text" class="baikalsr-building" placeholder="Строение"></input>
				</div>
			</div>
			<div class="control-group">
				<div class="control-label name">Квартира / Офис</div>
				<div class="controls">
					<input type="text" class="baikalsr-apt" placeholder=""></input>
				</div>
			</div>
		</div>
		<div id="baikalsr-terminal-group">
			<div class="control-group">
				<div class="control-label name">Терминал</div>
				<div class="controls">
					<select class="select2 baikalsr-ajax-terminal"></select>
				</div>
			</div>
		</div>
	</div>
</div>
<script type="text/javascript">
var baikalsr_shipping_method_id = '<?=$_SESSION ['baikalsr__shipping_method_id']?>';
var terminal_finish_only = true;
var shipping_price = "";
jQuery (document).ready (function () {
        
	sendFromType_radio(jQuery('input[name="baikalsr_shipping-type"]:checked').get(0));
	jQuery ("#baikalsr-calculator").detach ().appendTo ("#shipping_form_" + baikalsr_shipping_method_id);
	var city =[];
	if(typeof (shippingData.city) !== 'undefined' && shippingData.city){
		city = JSON.parse (
			jQuery.ajax ({
				url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getCityByGuid&args={"guid":"'  + shippingData.city + '"}',
				async: false
			}).responseText
		);
	}else if(typeof(cartData.city) !== 'undefined' && cartData.city){
		city = JSON.parse (
			jQuery.ajax ({
				url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getCityByName&args={"city":"'  + cartData.city + '"}',
				async: false
			}).responseText
		);		
	}
	if (city [0] !== undefined)
	{
		jQuery ('.baikalsr-ajax-city').append (
		jQuery ('<option>', {
				value: city [0].guid,
				text:  city [0].name
			})
		);
	}
	initAddressBoxes ();
	initTerminalBox (jQuery ('.baikalsr-ajax-city').val ());
	
	jQuery ('.baikalsr-ajax-city').change (function () {
		saveShippingDetails ();
		jQuery (".baikalsr-calculator").css ("opacity", "0.9");
		saveShippingMethod ();
		location.reload ();
    });
	jQuery ('.baikalsr-ajax-terminal').change (function () {
		jQuery ('.baikalsr-ajax-terminal').closest('.control-group').removeClass('error');
    });
	jQuery ('#shipping_form').submit (function () {
		if(jQuery('.baikalsr-ajax-city').val()== "-1"){
			jQuery('.baikalsr-ajax-city').closest('div[class="control-group"]').addClass('error');
			return false;
		}
		if (jQuery('input[name="baikalsr_shipping-type"]:checked').get(0).value == "2" ) {
			if(jQuery('.baikalsr-ajax-terminal').val()== "-1"){
				jQuery('.baikalsr-ajax-terminal').closest('div[class="control-group"]').addClass('error');
				return false;
			}
		}else{
			if(!jQuery('.baikalsr-ajax-street').val()){
				jQuery('.baikalsr-ajax-street').closest('div[class="control-group"]').addClass('error');
				return false;
			}
			if(!jQuery('.baikalsr-ajax-house').val()){
				jQuery('.baikalsr-ajax-house').closest('div[class="control-group"]').addClass('error');
				return false;
			}
		}
		
		saveShippingDetails ();
		return true;
	});
        
});
function saveShippingMethod() {
	var selectedShippingMethod = jQuery ('input[name="sh_pr_method_id"]:checked').attr ('id').split ('_') [2];
	jQuery.ajax ({
		url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=saveShippingMethod&args={"sm_id":' + selectedShippingMethod + "}",
		async: false,
	});
}
function saveShippingDetails() {
	
	if (jQuery('input[name="baikalsr_shipping-type"]:checked').get(0).value == "2" ) {
		saveTerminal ();
	} else {
		saveAddress ();
	}
}
	
function saveAddress(){
	var args = {
		'vars': {
			'is_terminal': 0,

			'house':        jQuery ('.baikalsr-ajax-house').val (),
			
			'housing':      jQuery ('.baikalsr-housing').val (),
			'building':     jQuery ('.baikalsr-building').val (),

			'apt':          jQuery ('.baikalsr-apt').val (),
			'street':       jQuery ('.baikalsr-ajax-street').val (),

			'house-text':   getHouseText (),
			'street-text':  jQuery ('.baikalsr-ajax-street').next ().text (),

			'city':         jQuery ('.baikalsr-ajax-city').val (),
			'city-text':    jQuery (".baikalsr-ajax-city").next().text (),

			'shipping-price': (shipping_price || "")
		}
	};

	jQuery.ajax ({
		url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=saveShippingDetails&args=' + JSON.stringify (args),
		async: false,
	});
}

function saveTerminal(){
	var args = {
		'vars': {
			'is_terminal': 1,

			'terminal': jQuery ('.baikalsr-ajax-terminal').val (),
			'terminal-text': jQuery ('.baikalsr-ajax-terminal option:selected').text(),
		
			'city': jQuery ('.baikalsr-ajax-city').val (),
			'city-text': jQuery (".baikalsr-ajax-city").next().text (),

			'shipping-price': (shipping_price || "")
		}
	};
	jQuery.ajax ({
		url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=saveShippingDetails&args=' + JSON.stringify (args),
		async: false,
	});
}

function sendFromType_radio(elem) {
	if( elem.checked ) {
		if( elem.value == "2" ) {
			jQuery('#baikalsr-address-group').hide();
			jQuery('#baikalsr-terminal-group').show();
		} else {
			jQuery('#baikalsr-address-group').show();
			jQuery('#baikalsr-terminal-group').hide();

		}
	}
	jQuery ('.baikalsr-ajax-city').trigger ('change');
}	
function getHouseText () {
	var customHousing  = jQuery ('.baikalsr-housing').val ();
	var customBuilding = jQuery ('.baikalsr-building').val ();

	if (customHousing || customBuilding)
	{
		var houseVal  = jQuery ('.baikalsr-ajax-house').val ().split ('|');
		var houseText = 'Дом ' + houseVal [1];

		if (customHousing)
		{
			houseText += ', Корпус ' + (customHousing ? customHousing : houseVal [2]);
		}

		if (customBuilding)
		{
			houseText += ', Строение ' + (customBuilding ? customBuilding : houseVal [3]);
		}

		return houseText;
	}
	else
	{
		var houseText = jQuery ('.baikalsr-ajax-house').next ().text ();

		return houseText;
	}
}	
</script>