<?php
defined ('_JEXEC') or die ('Restricted access');

jimport ('joomla.filesystem.folder');

class plgJshoppingOrderBaikalsr_shippingInstallerScript 
{
	/**
	 * Extension script constructor.
	 *
	 * @return  void
	 */
	public function __construct()
	{
		$this->minimum_php_release = JOOMLA_MINIMUM_PHP;
	}
	
	public function preflight ($type, $parent) 
    {		
		$error = 0;
		
		$app = JFactory::getApplication ();

		if (version_compare (phpversion (), $this->minimum_php_release, '<')) 
		{
			$app->enqueueMessage ('Plugin requires PHP ' . $this->minimum_php_release . ' or later version!', 'error');
			$error = 1;
		}

		if (!file_exists (JPATH_SITE . '/components/com_jshopping/jshopping.php'))
		{
			$app->enqueueMessage ('Please install component \"joomshopping\"', 'error');
			$error = 1;
		}

		if ($error) 
		{
			$app->enqueueMessage ('The installation was canceled', 'error');			
			return false;
		}

		return true;
	}

	public function postflight ($type, $parent)
    {
		$CurrentDir = $_SERVER ['DOCUMENT_ROOT'];

		$db = JFactory::getDbo ();

		JFolder::copy ( 
			"{$CurrentDir}/plugins/jshoppingorder/baikalsr_shipping/jshopping_addon/",
			"{$CurrentDir}", 
			"", 
			true
		);

		JFolder::delete (
			"{$CurrentDir}/plugins/jshoppingorder/baikalsr_shipping/jshopping_addon/"
		);


		$db->setQuery ("DELETE FROM `#__jshopping_shipping_ext_calc` WHERE alias = 'sm_baikalsr_shipping'");
		$db->execute  ();
		
		$db->setQuery ("
			INSERT INTO `#__jshopping_shipping_ext_calc` (`name`, `alias`, `description`, `params`, `shipping_method`, `published`, `ordering`) 
			VALUES (
				'БайкалСервис', 'sm_baikalsr_shipping', 'Расчет стоимости доставки с помощью API БайкалСервис', 
				'', '', 1, 1
			)
		");
		$db->execute  ();

		$db->setQuery ("DROP TABLE IF EXISTS `#__jshopping_baikalsr_settings`");
		$db->execute ();

		$db->setQuery ("
			CREATE TABLE `#__jshopping_baikalsr_settings` (
				`id` int NOT NULL PRIMARY KEY AUTO_INCREMENT,
				`name` text NOT NULL,
				`value` text NOT NULL
			) ENGINE=InnoDB;
		");
		$db->execute ();


		$db->setQuery ("
			INSERT INTO `#__jshopping_baikalsr_settings` (`id`, `name`, `value`) VALUES
				(1, 'TestMode', '1'),
				(2, 'ApiKey', ''),
				(3, 'ApiTestKey', '12341234123412341234123412341234'),
				(4, 'IsTerminal', '1'),
				(5, 'SenderCity', 'c2deb16a-0330-4f05-821f-1d09c93331e6'),
				(6, 'SenderStreet', 'd5954ac1-4745-451c-a482-acc0bd381ad0'),
				(7, 'SenderHouse', 'd5954ac1-4745-451c-a482-acc0bd381ad0|1/4||1'),
				(8, 'SenderTerminal', 'spb_mineralnaya'),
				(9, 'DefaultCargoType', '1421'),
				(10, 'DefaultPackageType', ''),
				(11, 'DefaultCargoLength', '0.2'),
				(12, 'DefaultCargoWidth', '0.3'),
				(13, 'DefaultCargoHeight', '0.4'),
				(14, 'DefaultCargoWeight', '2'),
				(15, 'AdditionalServices', '[\\\"3228\\\"]'),
				(16, 'OPF', '1_5'),
				(17, 'CompanyName', 'ООО \\\"Тест123\\\"'),
				(18, 'ContactPerson', 'Иван Иванов'),
				(19, 'Phone', ' 7 (111) 222-3333'),
				(20, 'Email', 'test@111.com'),
				(21, 'INN', '7743013333'),
				(22, 'KPP', '770200000'),
				(23, 'AddressNote', '13123121'),
				(24, 'ContragentGuid', '32973DB1-F9EE-35FF-4442-FC5F5FE7B9BF'),
				(25, 'CargoCalcType', 'summary'),
				(26, 'AuthorFirstName', 'Иван'),
				(27, 'AuthorLastName', 'Иванов'),
				(28, 'AuthorMiddleName', 'Иванович'),
				(29, 'AuthorEmail', 'default@mail.com'),
				(30, 'AuthorPhone', ' 7 (999) 888-7777'),
				(31, 'AuthorComment', '---'),
				(32, 'CargoDefaultSettingsType', 'unit'),
				(33, 'DefaultPRR', '0'),
				(34, 'DefaultFloor', '3'),
				(35, 'DefaultElevator', '1'),
				(36, 'SmallBagCount', '2'),
				(37, 'MiddleBagCount', '3'),
				(38, 'DetailedInfo', '1'),
				(39, 'SenderHousing', '11'),
				(40, 'SenderBuilding', '22'),
				(41, 'SenderApartment', '33');
		");
		
		$db->execute ();

		$db->setQuery ("
			CREATE TABLE IF NOT EXISTS `#__jshopping_baikalsr_orders` (
				`id` int NOT NULL PRIMARY KEY AUTO_INCREMENT,
				`order_id` int NOT NULL,
				`order_data` text NOT NULL,
				`track_number` text NOT NULL,
				`status` text NOT NULL,
				`request_id` int NOT NULL
			) ENGINE=InnoDB;
		");
		$db->execute ();	

		return true;
    }
}